$(document).ready(function () {
  $("body").on("change focus blur", ".visatype", getvouch);
  $("body").on("blur", ".manualno,.visano", chkexist);
  $("body").on("change", "#file", previewimg);
  $("body").on("change", ".file", preview_rowimg);
  $("body").off("click").on("click", ".remove", remove);
  $(".modalbody").on("click", ".tdsponsor", filval);
  $(".brokbody").on("click", ".tdbroker", brokfilval);
  $("body").on("click", ".imgshow", getImgModal);
  $("body").on("blur ", ".passport", getpassport);
  $("body").on("blur ", ".visaqty", getaddrows);
  //  $("body").on("blur ", ".manualno", getfileno);
  $("body").on("blur click change keyup", ".imig,.stamp,.mis,.mofa,.misc,.disc", Cal);
  $("body").on("blur click change keyup", ".misc_mod,.mis_mod,.imigamt_mod,.stampamt_mod,.mofamt_mod", TranAmt);
  $("#myEcr1").on("blur click change keyup", ".misc_mod1,.mis_mod1,.imigamt_mod1,.stampamt_mod1,.mofamt_mod1", ModalTot);
  $("body").on("blur", ".passport", checkSamePassport);
  $("body").on("click", ".edit1", edit1);
  $("body").on("click", ".savepart", savePart);
  $("body").on(" change  keyup click", ".edit1", getmodal);
  $("body").on("blur", ".visano,.idno", getBalVisaQty);


  function getBalVisaQty() {
    var visano = $(".visano").val(),
        idno = $(".idno").val(),
        visaqty = $(".visaqty").val();

    if (visaqty == 0) {
          $.post("get_balvisaqty.php", { visano: visano, idno: idno },
            function (data) {
              if (data != "") {
                $(".visaqty").val(data);
              }
            }
        );
    }
  }

  function getmodal() {
    var tr = $(this).closest("tr"),
      pax1 = tr.find(".paxname").val(),
      sex1 = tr.find(".sex").val(),
      pass1 = tr.find(".passport").val(),
      delvstatus1 = tr.find(".delvstatus").val(),
      dob1 = tr.find(".dob").val(),
      religion1 = tr.find(".religion").val(),
      pob1 = tr.find(".plbirth").val(),
      poi1 = tr.find(".issplace").val(),
      stay1 = tr.find(".periodstay").val(),
      issdate1 = tr.find(".issdate").val(),
      doe1 = tr.find(".doe").val(),
      stampdate1 = tr.find(".stampdate").val(),
      releasedt1 = tr.find(".releasedt").val(),
      submission_date1 = tr.find(".submission_date").val(),
      mofa_date1 = tr.find(".mofa_date").val(),
      mof1 = tr.find(".mofano").val(),
      mof2 = tr.find(".mofano2").val(),
      remark1 = tr.find(".tremark").val(),
      tadd1 = tr.find(".tadd").val(),
      category1 = tr.find(".category").val(),
      cateng1 = tr.find(".cateng").val(),
      mofamt_mod1 = tr.find(".mofamt_mod").val(),
      stampamt_mod1 = tr.find(".stampamt_mod").val(),
      imigamt_mod1 = tr.find(".imigamt_mod").val(),
      mis_mod1 = tr.find(".mis_mod").val(),
      misc_mod1 = tr.find(".misc_mod").val(),
      memcash1 = tr.find(".memcash").val();

    $(".pax1").val(pax1);
    $(".sex1").val(sex1).trigger("change");
    $(".pass1").val(pass1);
    $(".delvstatus1").val(delvstatus1);
    $(".dob1").val(dob1);
    $(".religion1").val(religion1);
    $(".pob1").val(pob1);
    $(".poi1").val(poi1);
    $(".stay1").val(stay1);
    $(".issdate1").val(issdate1);
    $(".doe1").val(doe1);
    $(".stampdate1").val(stampdate1);
    $(".releasedt1").val(releasedt1);
    $(".submission_date1").val(submission_date1);
    $(".mofa_date1").val(mofa_date1);
    $(".mof1").val(mof1);
    $(".mof2").val(mof2);
    $(".remark1").val(remark1);
    $(".tadd1").val(tadd1);
    $(".category1").val(category1);
    $(".cateng1").val(cateng1);
    $(".mofamt_mod1").val(mofamt_mod1);
    $(".stampamt_mod1").val(stampamt_mod1);
    $(".imigamt_mod1").val(imigamt_mod1);
    $(".mis_mod1").val(mis_mod1);
    $(".misc_mod1").val(misc_mod1);
    $(".memcash1").val(memcash1);

    $(".paxname").removeClass("datapax1");
    $(".sex").removeClass("datasex1");
    $(".passport").removeClass("datapass1");
    $(".delvstatus").removeClass("datadelvstatus1");
    $(".dob").removeClass("datadob1");
    $(".religion").removeClass("datareligion1");
    $(".plbirth").removeClass("datapob1");
    $(".issplace").removeClass("datapoi1");
    $(".periodstay").removeClass("datastay1");
    $(".issdate").removeClass("dataissdate1");
    $(".doe").removeClass("datadoe1");
    $(".stampdate").removeClass("datastampdate1");
    $(".releasedt").removeClass("datareleasedt1");
    $(".submission_date").removeClass("datasubmission_date1");
    $(".mofa_date").removeClass("datamofa_date1");
    $(".mofano").removeClass("datamof1");
    $(".mofano2").removeClass("datamof2");
    $(".tremark").removeClass("dataremark1");
    $(".tadd").removeClass("datatadd1");
    $(".category").removeClass("datacategory1");
    $(".cateng").removeClass("datacateng1");
    $(".mofamt_mod").removeClass("datamofamt_mod1");
    $(".stampamt_mod").removeClass("datastampamt_mod1");
    $(".imigamt_mod").removeClass("dataimigamt_mod1");
    $(".mis_mod").removeClass("datamis_mod1");
    $(".misc_mod").removeClass("datamisc_mod1");
    $(".memcash").removeClass("datamemcash1");

    tr.find(".paxname").addClass("datapax1");
    tr.find(".sex").addClass("datasex1");
    tr.find(".passport").addClass("datapass1");
    tr.find(".delvstatus").addClass("datadelvstatus1");
    tr.find(".dob").addClass("datadob1");
    tr.find(".religion").addClass("datareligion1");
    tr.find(".plbirth").addClass("datapob1");
    tr.find(".issplace").addClass("datapoi1");
    tr.find(".periodstay").addClass("datastay1");
    tr.find(".issdate").addClass("dataissdate1");
    tr.find(".doe").addClass("datadoe1");
    tr.find(".stampdate").addClass("datastampdate1");
    tr.find(".releasedt").addClass("datareleasedt1");
    tr.find(".submission_date").addClass("datasubmission_date1");
    tr.find(".mofa_date").addClass("datamofa_date1");
    tr.find(".mofano").addClass("datamof1");
    tr.find(".mofano2").addClass("datamof2");
    tr.find(".tremark").addClass("dataremark1");
    tr.find(".tadd").addClass("datatadd1");
    tr.find(".category").addClass("datacategory1");
    tr.find(".cateng").addClass("datacateng1");
    tr.find(".mofamt_mod").addClass("datamofamt_mod1");
    tr.find(".stampamt_mod").addClass("datastampamt_mod1");
    tr.find(".imigamt_mod").addClass("dataimigamt_mod1");
    tr.find(".mis_mod").addClass("datamis_mod1");
    tr.find(".misc_mod").addClass("datamisc_mod1");
    tr.find(".memcash").addClass("datamemcash1");
  }

  function edit1() {
    // var addflag = $(".addflag").val();
    // $("#myEcr1").modal("show");
    // if (addflag !== 1 || addflag == 1) {

    var tr = $(this).closest("tr");

    if (tr.find('.edit1').attr('disabled') !== undefined) {
    } else {
      $("#myEcr1").modal("show");
    }
  }

  function savePart() {
    var pax1 = $(".pax1").val(),
      sex1 = $(".sex1").val(),
      pass1 = $(".pass1").val(),
      delvstatus1 = $(".delvstatus1").val(),
      dob1 = $(".dob1").val(),
      religion1 = $(".religion1").val(),
      pob1 = $(".pob1").val(),
      poi1 = $(".poi1").val(),
      stay1 = $(".stay1").val(),
      issdate1 = $(".issdate1").val(),
      doe1 = $(".doe1").val(),
      stampdate1 = $(".stampdate1").val(),
      releasedt1 = $(".releasedt1").val(),
      submission_date1 = $(".submission_date1").val(),
      mofa_date1 = $(".mofa_date1").val(),
      mof1 = $(".mof1").val(),
      mof2 = $(".mof2").val(),
      remark1 = $(".remark1").val(),
      add1 = $(".tadd1").val(),
      category1 = $(".category1").val(),
      cateng1 = $(".cateng1").val(),
      memcash1 = $(".memcash1").val(),
      mofamt_mod1 = $(".mofamt_mod1").val(),
      stampamt_mod1 = $(".stampamt_mod1").val(),
      imigamt_mod1 = $(".imigamt_mod1").val(),
      mis_mod1 = $(".mis_mod1").val(),
      misc_mod1 = $(".misc_mod1").val();

    $(".datapax1").val(pax1);
    $(".datasex1").val(sex1).trigger("change");
    $(".datapass1").val(pass1);
    $(".datadelvstatus1").val(delvstatus1);
    $(".datadob1").val(dob1);
    $(".datareligion1").val(religion1);
    $(".datapob1").val(pob1);
    $(".datapoi1").val(poi1);
    $(".datastay1").val(stay1);
    $(".dataissdate1").val(issdate1);
    $(".datadoe1").val(doe1);
    $(".datastampdate1").val(stampdate1);
    $(".datareleasedt1").val(releasedt1);
    $(".datasubmission_date1").val(submission_date1);
    $(".datamofa_date1").val(mofa_date1);
    $(".datamof1").val(mof1);
    $(".datamof2").val(mof2);
    $(".dataremark1").val(remark1);
    $(".datatadd1").val(add1);
    $(".datacategory1").val(category1);
    $(".datacateng1").val(cateng1);
    $(".datamofamt_mod1").val(mofamt_mod1);
    $(".datastampamt_mod1").val(stampamt_mod1);
    $(".dataimigamt_mod1").val(imigamt_mod1);
    $(".datamis_mod1").val(mis_mod1);
    $(".datamisc_mod1").val(misc_mod1);
    $(".datamemcash1").val(memcash1);

    $(".pax1").removeClass("datapax1");
    $(".sex1").removeClass("datasex1");
    $(".pass1").removeClass("datapass1");
    $(".delvstatus1").removeClass("datadelvstatus1");
    $(".dob1").removeClass("datadob1");
    $(".religion1").removeClass("datareligion1");
    $(".pob1").removeClass("datapob1");
    $(".poi1").removeClass("datapoi1");
    $(".stay1").removeClass("datastay1");
    $(".issdate1").removeClass("dataissdate1");
    $(".doe1").removeClass("datadoe1");
    $(".stampdate1").removeClass("datastampdate1");
    $(".releasedt1").removeClass("datareleasedt1");
    $(".submission_date1").removeClass("datasubmission_date1");
    $(".mofa_date1").removeClass("datamofa_date1");
    $(".mof1").removeClass("datamof1");
    $(".mof2").removeClass("datamof2");
    $(".remark1").removeClass("dataremark1");
    $(".tadd").removeClass("datatadd1");
    $(".category1").removeClass("datacategory1");
    $(".cateng1").removeClass("datacateng1");
    $(".mofamt_mod1").removeClass("datamofamt_mod1");
    $(".stampamt_mod1").removeClass("datastampamt_mod1");
    $(".imigamt_mod1").removeClass("dataimigamt_mod1");
    $(".mis_mod1").removeClass("datamis_mod1");
    $(".misc_mod1").removeClass("datamisc_mod1");
    $(".memcash1").removeClass("datamemcash1");
    $("#myEcr1").modal("hide");
    TranTotal();
  }

  //  function getfileno() {
  //    var manualno = $(".manualno").val(),
  //      myvouch = $(".myvouch").val();
  //
  //    $.ajax({
  //      type: "POST",
  //      dataType: "json",
  //      url: "get_fileno.php",
  //      data: { manualno: manualno, myvouch: myvouch },
  //      success: function (response) {
  //        if (response != "") {
  //          var vcno = response.vouchno;
  //          var vcdt = response.vouchdt;
  //          var file = response.manualno;
  //
  //          var ctr = 0;
  //
  //          if (ctr <= 1) {
  //            alert("Already The same file is been used on " + vcdt + "");
  //            $(".manualno").val("");
  //            $(".manualno").focus();
  //
  //            ctr++;
  //          }
  //        }
  //      },
  //      error: function (request, textStatus, errorThrown) { },
  //    });
  //  }
  function getpassport() {
    var tr = $(this).closest("tr"),
      passport = tr.find(".passport").val(),
      myvouch = $(".myvouch").val();
    $.ajax({
      type: "POST",
      dataType: "json",
      url: "get_passport.php",
      data: { passport: passport, myvouch: myvouch },
      success: function (response) {
        //                $(".passport").val(response[0].party).trigger('change');
        //                tr(".passport").val(response.passport);
        if (response != "") {
          var vcno = response.vouchno;
          var vcdt = response.vouchdt;
          var ctr = 0;

          if (ctr <= 1) {
            alert(
              "Already The same passport is been used on " +
              vcdt +
              "   passport no   " +
              passport +
              "  having voucher no  " +
              vcno +
              ""
            );

            ctr++;
          }
        }
      },
      error: function (request, textStatus, errorThrown) { },
    });
  }

  function checkSamePassport() {
    var tr = $(this).closest("tr"),
      sr = tr.find(".srno").val(),
      passport = tr.find(".passport").val();
    if (passport != "") {
      $(".tbody")
        .find("tr")
        .each(function () {
          var row = $(this);
          var srno = row.find(".srno").val();
          var passchk = row.find(".passport").val();
          if (passport == passchk && srno != sr) {
            alert("Passport  Already Exist  at Sr.  " + srno);
            tr.find(".passport").val("");
            tr.find(".passport").focus();
            return false;
          }
        });
    }
  }

  function getImgModal() {
    var tr = $(this).closest("tr"),
      vouchno = $(".myvouch").val(),
      srno = tr.find(".srno").val();
    if (vouchno != "" && srno != "") {
      $.post(
        "showImage.php",
        { vouchno: vouchno, srno: srno },
        function (data) {
          if (data != "") {
            $(".tbody4").html(data);
            $(".imgModal").modal("show");
          }
        }
      );
    }
  }

  function brokfilval() {
    var tr = $(this).closest("tr"),
      broker = tr.find(".tdbroker").text();
    $("#broker").val(broker);
    $("#myBroker").modal("hide");
    $(".email").focus();
  }

  function ModalTot() {
    var mofamt_mod1 = $(".mofamt_mod1").val();
    var stampamt_mod1 = $(".stampamt_mod1").val();
    var imigamt_mod1 = $(".imigamt_mod1").val();
    var mis_mod1 = $(".mis_mod1").val();
    var misc_mod1 = $(".misc_mod1").val();
    var totmemcash1 =
      parseInt(mofamt_mod1) +
      parseInt(stampamt_mod1) +
      parseInt(imigamt_mod1) +
      parseInt(mis_mod1) +
      parseInt(misc_mod1);
    $(".memcash1").val(totmemcash1);
    TranTotal();
  }

  function TranAmt() {
    var tr = $(this).closest("tr");
    var mofamt_mod = tr.find(".mofamt_mod").val();
    var stampamt_mod = tr.find(".stampamt_mod").val();
    var imigamt_mod = tr.find(".imigamt_mod").val();
    var mis_mod = tr.find(".mis_mod").val();
    var misc_mod = tr.find(".misc_mod").val();
    var totmemcash =
      parseInt(mofamt_mod) +
      parseInt(stampamt_mod) +
      parseInt(imigamt_mod) +
      parseInt(mis_mod) +
      parseInt(misc_mod);
    tr.find(".memcash").val(totmemcash);
    TranTotal();
  }

  function TranTotal() {
    var totmofamt_mod = 0;
    var totstampamt_mod = 0;
    var totimigamt_mod = 0;
    var totmis_mod = 0;
    var totmisc_mod = 0;

    $(".mofamt_mod").each(function () {
      if (!isNaN(this.value) && this.value.length != 0) {
        totmofamt_mod += parseFloat(this.value);
      }
    });
    $(".stampamt_mod").each(function () {
      if (!isNaN(this.value) && this.value.length != 0) {
        totstampamt_mod += parseFloat(this.value);
      }
    });
    $(".imigamt_mod").each(function () {
      if (!isNaN(this.value) && this.value.length != 0) {
        totimigamt_mod += parseFloat(this.value);
      }
    });
    $(".mis_mod").each(function () {
      if (!isNaN(this.value) && this.value.length != 0) {
        totmis_mod += parseFloat(this.value);
      }
    });
    $(".misc_mod").each(function () {
      if (!isNaN(this.value) && this.value.length != 0) {
        totmisc_mod += parseFloat(this.value);
      }
    });
    var totmofamt = parseFloat(totmofamt_mod);
    var totstampamt = parseFloat(totstampamt_mod);
    var totimigamt = parseFloat(totimigamt_mod);
    var totmisamt = parseFloat(totmis_mod);
    var totmiscamt = parseFloat(totmisc_mod);

    $(".mofa").val(totmofamt);
    $(".stamp").val(totstampamt);
    $(".imig").val(totimigamt);
    $(".mis").val(totmisamt);
    $(".misc").val(totmiscamt);
    Cal();
  }

  function Cal() {
    var imig = $(".imig").val();
    var stamp = $(".stamp").val();
    var mis = $(".mis").val();
    var mofa = $(".mofa").val();
    var misc = $(".misc").val(),
      total =
        parseFloat(imig) +
        parseFloat(stamp) +
        parseFloat(mis) +
        parseFloat(mofa) +
        parseFloat(misc);
    $(".total").val(total);
    var disc = $(".disc").val();
    var final = parseFloat(total) - parseFloat(disc);
    $(".tot").val(final);
  }

  $("#broksrch").keyup(function () {
    var ssearch = $("#broksrch").val();

    if (ssearch != "") {
      $.get("get_broker.php", { ssearch: ssearch }, function (data) {
        $(".brokbody").html(data);
      });
    }
  });

  $("#brksrch").click(function () {
    var sponsor = $(".sponsor").val();
    if (sponsor == "") {
      $.get("get_broker.php", function (data) {
        $("#myBroker").modal("show");
        $(".brokbody").html(data);
      });
    }
  });

  function filval() {
    var tr = $(this).closest("tr"),
      sponsor = tr.find(".tdsponsor").text();
    $("#sponsor").val(sponsor);
    $("#myModal").modal("hide");
    $(".broker").focus();
  }

  $("#sponsrch").keyup(function () {
    var ssearch = $("#sponsrch").val();

    if (ssearch != "") {
      $.get("get_sponsor.php", { ssearch: ssearch }, function (data) {
        $(".modalbody").html(data);
      });
    }
  });

  $("#spnname").click(function () {
    var sponsor = $(".sponsor").val();
    if (sponsor == "") {
      $.get("get_sponsor.php", function (data) {
        $("#myModal").modal("show");
        $(".modalbody").html(data);
      });
    }
  });

  $("#hsearch").hide();
  $("#hprevious").hide();
  $("#hnext").hide();
  //    $("#hprint").hide();

  $("#preview").dblclick(function () {
    var src = $(this).attr("src");
    window.open(src, "_blank");
  });

  $(".preview").dblclick(function () {
    var src = $(this).attr("src");
    window.open(src, "_blank");
  });

  $(".visa").click(function () {
    $(".VisaModal").modal("show");
  });

  $("#hedit").click(function () {
    stopedit();
  });

  function stopedit() {
    var addflag = $(".addflag").val();

    if (addflag !== 1) {
      //            $('.visatype').prop('disabled', 'disabled');
    }
  }

  $(".newsave").click(function () {
    $(".tbody3")
      .find("tr")
      .each(function () {
        var row = $(this),
          code = row.find(".code").val(),
          name = row.find(".tname").val();
        if (name != "") {
          $.post("save_new.php", { code: code, name: name }, function (data) {
            $(".visatype").html(data).trigger("change");
          });
        }
      });
    $(".VisaModal").modal("hide");
  });

  $(window).keydown(function (event) {
    if (event.altKey && event.keyCode == 84) {
      // Alt+T
      $(".VisaModal").modal("show");
    }
  });

  function previewimg() {
    function readIMG(input) {
      if (input.files && input.files[0]) {
        var reader = new FileReader();

        reader.onload = function (e) {
          $("#preview").attr("src", e.target.result);
        };

        reader.readAsDataURL(input.files[0]);
      }
    }
    readIMG(this);
  }

  function preview_rowimg() {
    var tr = $(this).closest("tr");

    function readIMG(input) {
      if (input.files && input.files[0]) {
        var reader = new FileReader();

        reader.onload = function (e) {
          tr.find(".preview").attr("src", e.target.result);
        };

        reader.readAsDataURL(input.files[0]);
      }
    }
    readIMG(this);
  }

  function getaddrows() {
    var visaqty = $(".visaqty").val();
    var items = $("#items").val();
    var c = items;

    for (i = c; i < visaqty; i++) {
      $("#addnew").click();
      items++;
      //      console.log(items);

      $("#items").val(items);
      console.log(items);
    }
  }

  function remove() {
    if ($(this).hasClass("rdel")) {
      var tr = $(this).closest("tr"),
        code = tr.find(".code").val(),
        element = $(this).closest("tr"),
        addflag = $(".addflag").val(),
        name = tr.find(".tname").val();
      if (confirm("Do You Want To Delete ?")) {
        $(this).closest("tr").remove();
        $.post("del.php", { code: code, name: name }, function (data) {
          if (data !== "") {
            if (data === "Cannot Delete Entries Exist For This Visatype.") {
              alert(data);
              $(".tbody3").append(element);
            } else {
              if (addflag === 1) {
                $(".visatype").html(data).trigger("change");
              }
            }
          }
        });
      }
    } else {
      $(this).closest("tr").remove();
    }
  }

  function chkexist() {
    var visatype = $(".visatype").val(),
      manualno = $(".manualno").val(),
      visano = $(".visano").val(),
      id = $(this).attr("id"),
      voucher = $(".voucher").val();

    if (id === "visano") {
      //      if (visano !== "") {
      //        $.post(
      //          "chk_exist.php",
      //          { visatype: visatype, voucher: voucher, visano: visano, id: id },
      //          function (data) {
      //            if (data != "") {
      //              $(".visano").val("");
      //              alert(data);
      //              $(".visano").focus();
      //            }
      //          }
      //        );
      //      }
    } else {
      //      if (manualno !== "") {
      //        $.post(
      //          "chk_exist.php",
      //          { visatype: visatype, voucher: voucher, manualno: manualno, id: id },
      //          function (data) {
      //            if (data != "") {
      //              $(".manualno").val("");
      //              alert(data);
      //              $(".manualno").focus();
      //            }
      //          }
      //        );
      //      }
    }
  }

  function getvouch() {
    var visatype = $(".visatype").val(),
      addflag = $(".addflag").val(),
      voucher = $(".voucher").val();
    if (addflag == 1) {
      $.post("get_vouch.php", { visatype: visatype }, function (data) {
        $(".voucher").val(data);
      });
      //       $.post("gen_fileno.php", { visatype: visatype }, function (data) {
      //         $(".manualno").val(data);
      //       });
    }
  }

  $("#addnew").click(function () {
    AddRows();
  });

  $("#addnew2").click(function () {
    AddRows2();
  });

  $("#addnew3").click(function () {
    AddRows3();
  });

  function AddRows() {
    var ctr = $("#items").val();
    var addflg = $(".addflg").val();
    var hide_check = "";
    if ($("#del_all").prop("checked")) {
      hide_check = 0;
    } else {
      hide_check = 1;
    }
    $.post(
      "pax_add.php",
      { ctr: ctr, hide: hide_check, addflg: addflg },
      function (data) {
        $(data).appendTo(".tbody");
        ctr++;
        $("#items").val(ctr);
      }
    );
  }

  function AddRows2() {
    var ctr = $("#items2").val();
    var hide_check = "";
    if ($("#del_all").prop("checked")) {
      hide_check = 0;
    } else {
      hide_check = 1;
    }
    $.post("category_add.php", { ctr: ctr, hide: hide_check }, function (data) {
      $(data).appendTo(".tbody2");
      ctr++;
      $("#items2").val(ctr);
    });
  }

  function AddRows3() {
    var hide_check = "";
    var ctr = "";
    if ($("#del_all").prop("checked")) {
      hide_check = 0;
    } else {
      hide_check = 1;
    }
    $.post("type_add.php", { ctr: ctr, hide: hide_check }, function (data) {
      $(data).appendTo(".tbody3");
    });
  }
});
